#include "iRRAM.h"

/*
 Test Inversion of matrices, similar to 'matrix.cc', but with
 matrices of very bad condition.
*/

void compute(){
  REALMATRIX m,n,o;
  long size,i,j;

  rprintf("Inversion of Hilbert matrix\n");
  rprintf("Size of matrix: ");
  rscanf("%d",&size);
  rprintf("\n");

  m=REALMATRIX(size,size);
  for (i=0;i<size;i++)
  for (j=0;j<size;j++)
    m(i,j)=1/REAL(i+j+1);
 
  o=eye(size);
 
  rprintf("Matrix H:\n");
  rwrite(m,10);
//  rwrite(m,-50,10);
  rprintf("\n");

  n=o/m;

  rprintf("Matrix K=inv(H):\n");
//  rwrite(n,-50,10);
  rwrite(n,10);
  rprintf("\n");

  rprintf("Maximum norm of K: ");
  REAL mn=maxnorm(n);
  rshow(mn,20);
  rprintf("\n");
  rprintf("\n");

  o=m*n;

  rprintf("Matrix K*H:\n");
//  rwrite(o,-50,10);
  rwrite(o,10);
  rprintf("\n");
};
