#include "iRRAM.h"

/* Compute iterated system x=3.75*x*(1-x) (Kulisch) */

void compute(){
  int test,count;
  rprintf("Logistic sequence: x=3.75*x*(1-x) (Kulisch)\n");
  rprintf("How many values: ");
  rscanf("%d",&count);

  REAL   xr= 0.5,   cr=3.75;
  RATIONAL xq= 0.5, cq=3.75;
  double xd= 0.5, cd=3.75;
  for (long i=1;i<=count;i++ ) {
    rprintf("%f %f %f %d\n",double(xr), xd, double(REAL(xq)), i);
    xr=cr*xr*(1-xr);
    xd=cd*xd*(1-xd);
    xq=cq*xq*(1-xq);
  }
};
