#include "iRRAM.h"

/* Simple test program:  working with matrices */

void compute(){
  int size=3;
  REALMATRIX m(size,size),n(size,size),o(size,size); 

/* Initializing matrix m*/
   m(0,0)=2;
   m(0,1)=0;
   m(0,2)=0;
   m(1,0)=0;
   m(1,1)=1;
   m(1,2)=2;
   m(2,0)=0;
   m(2,1)=2;
   m(2,2)=3;
 
   rprintf("example matrix m:\n\n");
   rwrite(m,-200,10);

/* Initializing matrix o as unit */

   o=eye(size);

/* Computing the inverse of m */

   n=o/m;

/* Printing the inverse */
   rprintf("\nmatrix n=o/m:\n\n");
   rwrite(n,-200,10);

/* Multiplying m and its inverse */

   rprintf("\nmatrix m*n:\n\n");
   o=m*n;

/* Printing the resulting product */
   rwrite(o,-200,10);

/* Testing the matrix exponential function */

  o= exp(eye(size));
  rprintf("\nmatrix exp(eye(size)):\n\n");
  rwrite(o,-200,10);

/* Another test for the "scaling and squaring" method */

  REALMATRIX p(2,2);
  p(0,0)=-49;
  p(0,1)= 24;
  p(1,0)=-64;
  p(1,1)= 31;
  rprintf("\n\nmatrix p:\n\n");
  rwrite(p,-200,10);

  p= exp(p);

  rprintf("\nmatrix exp(p):\n\n");
  rwrite(p,-200,10);

};
