#include "gmp.h"

#ifdef __cplusplus
extern "C" {
#endif



#define DEFINITION_Dyadic_Base

#define Dyadic_Base_MAXSIZE	100000

#define BOOLEAN unsigned char

#define Dyadic_Base_BITZAHL	mp_bits_per_limb
#define Dyadic_Base_MinInt	-(1<<(mp_bits_per_limb-3))

#define BASIS	4294967296ULL


typedef  mp_limb_t Dyadic_Base_WertFeld[Dyadic_Base_MAXSIZE];

inline void Dyadic_Base_SysAdd ( 
               Dyadic_Base_WertFeld A,
               Dyadic_Base_WertFeld B,
               Dyadic_Base_WertFeld C,
               long ANZAHL);

inline void Dyadic_Base_SysSub (
               Dyadic_Base_WertFeld A,
               Dyadic_Base_WertFeld B,
               Dyadic_Base_WertFeld C,
               long ANZAHL,
               BOOLEAN *NEGATIV);

inline void Dyadic_Base_SysBlockShl (
               Dyadic_Base_WertFeld A,
               long ANZAHL,
               long COUNT);

inline void Dyadic_Base_SysMul (
               Dyadic_Base_WertFeld A,
               Dyadic_Base_WertFeld B,
               Dyadic_Base_WertFeld C,
               long Aanzahl,
               long Banzahl,
               long Canzahl);

inline void Dyadic_Base_SysDiv (
               Dyadic_Base_WertFeld A, 
               Dyadic_Base_WertFeld B,
               Dyadic_Base_WertFeld C,
               long Aanzahl,
               long Banzahl,
               long Canzahl,
  BOOLEAN MODUL);

#ifdef __cplusplus
}
#endif
