#include "iRRAM.h"

/* Compute faculty using different data types */

void faculty_double(long count){
  double x = 1;

  for ( long i=1; i<=count; i++ ) {
    x= x*i;
    if ( (i<100) || (i%10)==0 ) {
      rprintf("%13.10e",x); rprintf(" %d\n",i);
    }
  }
}


void faculty_REAL(long count){

  REAL x = 1;

  for ( long i=1; i<=count; i++ ) {
    x= x*i;
    if ( (i<100) || (i%10)==0 ) {
      rwrite(x,50); rprintf(" %d\n",i);
    }
  }
}


void faculty_REAL_int(long count){

  REAL x = 1;

  for ( long i=1; i<=count; i++ ) {
    x= x*i;
    if ( (i<100) || (i%10)==0 ) {
      rwrite(INTEGER(x),50); rprintf(" %d\n",i);
    }
  }
}


void faculty_RATIONAL(long count){

  RATIONAL x = 1;
   for ( long i=1; i<=count; i++ ) {
    x= x*i;
    if ( (i<100) || (i%10)==0 ) {
      rwrite(x,50); rprintf(" %d\n",i);
    }
  }
}



void faculty_INTEGER(long count){


  INTEGER x = 1;

  for ( long i=1; i<=count; i++ ) {
    x= x*i;
    if ( (i<100) || (i%10)==0 ) {
      rwrite(x,50); rprintf(" %d\n",i);
    }
  }
}

void faculty_INTEGER_real(long count){


  INTEGER x = 1;

  for ( long i=1; i<=count; i++ ) {
    x= x*i;
    if ( (i<100) || (i%10)==0 ) {
      rwrite(REAL(x),50); rprintf(" %d\n",i);
    }
  }
}


void compute(){
  long test,count;
  rprintf("Faculty: x = n!\n");
  rprintf("how to compute (1=REAL, 2=double, 3=RATIONAL, 4=INTEGER 5=REAL with int-output, 6 INTEGER with REAL-output) : ");
  rscanf("%d",&test);
  rprintf("how many values: ");
  rscanf("%d",&count);
  rprintf("\n");
  switch (test) {
     case 1:;
       faculty_REAL(count);
     break;
     case 2:;
       faculty_double(count);
     break;
     case 3:;
       faculty_RATIONAL(count);
     break;
     case 4:;
       faculty_INTEGER(count);
     break;
     case 5:;
       faculty_REAL_int(count);
     break;
     case 6:;
       faculty_INTEGER_real(count);
     break;
  }


};
