#include "iRRAM.h"

/* Compute iteration by J.M.Muller */

void compute(){
  int test,count;
  rprintf("JMM-example: c=111-(1130-3000/a)/b\n");
  rprintf("How many values: ");
  rscanf("%d",&count);
  rprintf("\n");

  DYADIC_precision P(-100);
  float    af= float(11)/2,    bf=float(61)/11,    cf;
  double   ad= double(11)/2,   bd=double(61)/11,   cd;
  DYADIC   aD= DYADIC(11)/2,   bD=DYADIC(61)/11,   cD;
  RATIONAL aq= RATIONAL(11)/2, bq=RATIONAL(61)/11, cq;
  REAL     aR= REAL(11)/2,     bR=REAL(61)/11,     cR;
  for (long i=0;i<=count;i++ ) {
    rprintf("%d %f %f %f %f %f\n", i, af, ad, 
      double(REAL(aD)),double(REAL(aq)), double(aR));
    cD=111-(1130-3000/aD)/bD;    aD=bD; bD=cD;   
    cR=111-(1130-3000/aR)/bR;    aR=bR; bR=cR;   
    cf=111-(1130-3000/af)/bf;    af=bf; bf=cf;   
    cd=111-(1130-3000/ad)/bd;    ad=bd; bd=cd;   
    cq=111-(1130-3000/aq)/bq;    aq=bq; bq=cq;   
  }
};
