#define do_not_activate_iRRAM_control // the main routine is user-defined
#include "iRRAM.h"      // basic includes
#include "iRRAM_core.h" // additional includes for templates

// iRRAM-routine to compute a DYADIC cosine
DYADIC compute_cos(DYADIC x, long p) { return approx(cos(REAL(x)),p); }

template DYADIC iRRAM_exec <DYADIC,long,DYADIC> 
(DYADIC (*) (DYADIC,long),DYADIC,long);



// main routine that internally calls iRRAM three times:
int main (int argc,char **argv)
{
iRRAM_initialize(argc,argv);
DYADIC d=2.0,d2;
long p=-10;

d2=iRRAM_exec(compute_cos,d,p);

rwrite(iRRAM_exec(compute_cos,d,p),100);rprintf("\n");

}


